Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.value
Class Closure

    java.lang.Object
      net.sf.saxon.value.Value
          net.sf.saxon.value.Closure

All Implemented Interfaces:
  Serializable, SequenceIterable, ValueRepresentation

Direct Known Subclasses:
  MemoClosure, SingletonClosure

    public class Closure

extends Value

A Closure represents a value that has not yet been evaluated: the value is represented by an expression, together with saved values of all the context variables that the expression depends on.

This Closure is designed for use when the value is only read once. If the value is read more than once, a new iterator over the underlying expression is obtained each time: this may (for example in the case of a filter expression) involve significant re-calculation.

The expression may depend on local variables and on the context item; these values are held in the saved XPathContext object that is kept as part of the Closure, and they will always be read from that object. The expression may also depend on global variables; these are unchanging, so they can be read from the Bindery in the normal way. Expressions that depend on other contextual information, for example the values of position(), last(), current(), current-group(), should not be evaluated using this mechanism: they should always be evaluated eagerly. This means that the Closure does not need to keep a copy of these context variables.

See Also:
  Serialized Form

Field Summary
`protected int` | `depth`
`protected Expression` | `expression`
`protected SequenceIterator` | `inputIterator`
`protected XPathContextMajor` | `savedXPathContext`

Fields inherited from class net.sf.saxon.value.Value
`INDETERMINATE_ORDERING`

Fields inherited from interface net.sf.saxon.om.ValueRepresentation
`EMPTY_VALUE_ARRAY`

Constructor Summary
`Closure()` Constructor should not be called directly, instances should be made using the make() method.

Method Summary
`int` | `getCardinality()` Get the cardinality
`ItemType` | `getItemType(TypeHierarchy th)` Get the static item type
`SequenceIterator` | `iterate()` Evaluate the expression in a given context to return an iterator over a sequence
`static Value` | `make(Expression expression, XPathContext context, int ref)` Construct a Closure by supplying the expression and the set of context variables.
`static ValueRepresentation` | `makeIteratorClosure(SequenceIterator iterator)` Construct a Closure over an existing SequenceIterator.
`void` | `process(XPathContext context)` Process the instruction, without returning any tail calls
`Value` | `reduce()` Reduce a value to its simplest form.
`protected void` | `saveContext(Expression expression, XPathContext context)`

Methods inherited from class net.sf.saxon.value.Value
`asItem, asItem, asIterator, asValue, checkPermittedContents, convertToJava, effectiveBooleanValue, equals, fromItem, getCanonicalLexicalRepresentation, getIterator, getLength, getSchemaComparable, getStringValue, getStringValueCS, hashCode, isIdentical, itemAt, iterate`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### expression

    protected Expression expression

### savedXPathContext

    protected XPathContextMajor savedXPathContext

### depth

    protected int depth

### inputIterator

    protected SequenceIterator inputIterator

Constructor Detail

### Closure

    public Closure()

  Constructor should not be called directly, instances should be made using the make() method.

Method Detail

### makeIteratorClosure

    public static ValueRepresentation makeIteratorClosure(SequenceIterator iterator)
                                                   throws XPathException

  Construct a Closure over an existing SequenceIterator. This is used when an extension function returns a SequenceIterator as its result (it replaces the old SequenceIntent class for this purpose). There is no known expression in this case. Note that the caller must ensure this is a "clean" iterator: it must be positioned at the start, and must not be shared by anyone else.

  Parameters:
    `iterator` - the supplied iterator
  Returns:
    the Closure over this iterator
  Throws:
    `XPathException`

### make

    public static Value make(Expression expression,
                             XPathContext context,
                             int ref)
                      throws XPathException

  Construct a Closure by supplying the expression and the set of context variables.

  Parameters:
    `expression` - the expression to be lazily evaluated
    `context` - the dynamic context of the expression including for example the variables on which it depends
    `ref` - the number of references to the value being lazily evaluated; this affects the kind of Closure that is created
  Returns:
    the Closure, a virtual value that can later be materialized when its content is required
  Throws:
    `XPathException`

### saveContext

    protected void saveContext(Expression expression,
                               XPathContext context)
                        throws XPathException

  Throws:
    `XPathException`

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Get the static item type

  Overrides:
    `getItemType` in class `Value`
  Parameters:
    `th` - the type hierarchy cache
  Returns:
    for the default implementation: AnyItemType (not known)

### getCardinality

    public int getCardinality()

  Get the cardinality

  Overrides:
    `getCardinality` in class `Value`
  Returns:
    the cardinality

### iterate

    public SequenceIterator iterate()
                             throws XPathException

  Evaluate the expression in a given context to return an iterator over a sequence

  Specified by:
    `iterate` in class `Value`
  Returns:
    an iterator over the sequence of items
  Throws:
    `XPathException` - if a dynamic error occurs. This is possible only in the case of values that are materialized lazily, that is, where the iterate() method leads to computation of an expression that delivers the values.

### process

    public void process(XPathContext context)
                 throws XPathException

  Process the instruction, without returning any tail calls

  Overrides:
    `process` in class `Value`
  Parameters:
    `context` - The dynamic context, giving access to the current node, the current variables, etc.
  Throws:
    `XPathException`

### reduce

    public Value reduce()
                 throws XPathException

  Reduce a value to its simplest form. If the value is a closure or some other form of deferred value such as a FunctionCallPackage, then it is reduced to a SequenceExtent. If it is a SequenceExtent containing a single item, then it is reduced to that item. One consequence that is exploited by class FilterExpression is that if the value is a singleton numeric value, then the result will be an instance of NumericValue

  Overrides:
    `reduce` in class `Value`
  Returns:
    the value in simplified form
  Throws:
    `XPathException`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2010 Saxonica Limited. All rights reserved.